// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>
//
//          streamCapture2
//          (C) Copyright  2016 - 2024 Ingemar Ceicer
//          https://gitlab.com/posktomten/streamcapture2/
//          programming@ceicer.com
//
//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>

#include "newprg.h"

void Newprg::english()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                       EXECUTABLE_NAME);
    // settings.setIniCodec("UTF-8");
    settings.beginGroup("Language");
    QString sp = settings.value("language", "").toString();
    settings.endGroup();

    if(sp != "en_US") {
        QIcon iconYes(QPixmap(":/images/restart.png"));
        QIcon iconReject(QPixmap(":/images/exit.png"));
        QMessageBox *msgBox = new QMessageBox(this);
        QPushButton  *yesButton = new QPushButton(iconYes, tr("Restart Now"), msgBox);
        QPushButton  *rejectButton = new QPushButton(iconReject, tr("Cancel"), msgBox);
        msgBox->addButton(yesButton, QMessageBox::YesRole);
        msgBox->addButton(rejectButton, QMessageBox::RejectRole);
        msgBox->setDefaultButton(yesButton);
        msgBox->setWindowTitle(DISPLAY_NAME " " VERSION);
        msgBox->setText(tr("The program must be restarted for the new language settings to take effect."));

        if(msgBox->exec() == 0) {
            settings.beginGroup("Language");
            settings.setValue("language", "en_US");
            settings.endGroup();
            settings.sync();
            const QString EXECUTE =
                QCoreApplication::applicationDirPath() + "/" +
                QFileInfo(QCoreApplication::applicationFilePath()).fileName();
            QProcess p;
            p.setProgram(EXECUTE);
            p.startDetached();
            close();
        } else {
            delete msgBox;
            return;
        }
    }
}
void Newprg::swedish()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                       EXECUTABLE_NAME);
    // settings.setIniCodec("UTF-8");
    settings.beginGroup("Language");
    QString sp = settings.value("language", "").toString();
    settings.endGroup();

    if(sp != "sv_SE") {
        sp = "sv_SE";
        QMessageBox *msgBox = new QMessageBox(this);
        QIcon iconYes(QPixmap(":/images/restart.png"));
        QIcon iconReject(QPixmap(":/images/exit.png"));
        QPushButton  *yesButton = new QPushButton(iconYes, tr("Restart Now"), msgBox);
        QPushButton  *rejectButton = new QPushButton(iconReject, tr("Cancel"), msgBox);
        msgBox->addButton(yesButton, QMessageBox::YesRole);
        msgBox->addButton(rejectButton, QMessageBox::RejectRole);
        msgBox->setDefaultButton(yesButton);
        msgBox->setWindowTitle(DISPLAY_NAME " " VERSION);
        msgBox->setText(tr("The program must be restarted for the new language settings to take effect."));

        if(msgBox->exec() == 0)  {
            settings.beginGroup("Language");
            settings.setValue("language", sp);
            settings.endGroup();
            settings.sync();
            const QString EXECUTE =
                QCoreApplication::applicationDirPath() + "/" +
                QFileInfo(QCoreApplication::applicationFilePath()).fileName();
            QProcess p;
            p.setProgram(EXECUTE);
            p.startDetached();
            close();
        } else  {
            delete msgBox;
            return;
        }
    }
}
void Newprg::italian()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                       EXECUTABLE_NAME);
    // settings.setIniCodec("UTF-8");
    settings.beginGroup("Language");
    QString sp = settings.value("language", "none").toString();
    settings.endGroup();

    if(sp != "it_IT") {
        sp = "it_IT";
        QMessageBox *msgBox = new QMessageBox(this);
        QIcon iconYes(QPixmap(":/images/restart.png"));
        QIcon iconReject(QPixmap(":/images/exit.png"));
        QPushButton  *yesButton = new QPushButton(iconYes, tr("Restart Now"), msgBox);
        QPushButton  *rejectButton = new QPushButton(iconReject, tr("Cancel"), msgBox);
        msgBox->addButton(yesButton, QMessageBox::YesRole);
        msgBox->addButton(rejectButton, QMessageBox::RejectRole);
        msgBox->setDefaultButton(yesButton);
        msgBox->setWindowTitle(DISPLAY_NAME " " VERSION);
        msgBox->setText(tr("The program must be restarted for the new language settings to take effect."));

        if(msgBox->exec() == 0) {
            settings.beginGroup("Language");
            settings.setValue("language", sp);
            settings.endGroup();
            settings.sync();
            const QString EXECUTE =
                QCoreApplication::applicationDirPath() + "/" +
                QFileInfo(QCoreApplication::applicationFilePath()).fileName();
            QProcess p;
            p.setProgram(EXECUTE);
            p.startDetached();
            close();
        } else  {
            delete msgBox;
            return;
        }
    }
}
