// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>
//
//          streamCapture2
//          (C) Copyright  2016 - 2024 Ingemar Ceicer
//          https://gitlab.com/posktomten/streamcapture2/
//          programming@ceicer.com
//
//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>

#include "newprg.h"
#include "zoom_disable.h"
int main(int argc, char *argv[])
{
#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);
    QCoreApplication::setAttribute(Qt::AA_UseHighDpiPixmaps);
#endif
#ifdef Q_OS_LINUX
    QCoreApplication::setAttribute(Qt::AA_DontUseNativeDialogs, true);
    QCoreApplication::setAttribute(Qt::AA_NativeWindows, true);
#endif
    QString currentLocale(QLocale::system().name());
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                       EXECUTABLE_NAME);
    // settings.setIniCodec("UTF-8");
    settings.beginGroup("Language");
    // cppcheck sp -> sprak
    QString sprak = settings.value("language", currentLocale).toString();
    settings.endGroup();
    settings.beginGroup("Settings");
    QString theme = settings.value("theme", "system").toString();
    settings.endGroup();
    QApplication app(argc, argv);
    // FONT
    // fonts/segoeui.ttf
// #if defined(Q_OS_WINDOWS)
//     int id = QFontDatabase::addApplicationFont(":/fonts/segoeui.ttf");
// #endif
// #if defined(Q_OS_LINUX)
//     int id = QFontDatabase::addApplicationFont(":/fonts/Ubuntu-M.ttf");
// #endif
//     QString family = QFontDatabase::applicationFontFamilies(id).at(0);
//     QFont _font(family, 10);
//     app.setFont(_font);
    // app.setAttribute(Qt::AA_Use96Dpi);
    /*   */
    QApplication::setStyle(QStyleFactory::create("Fusion"));
    QLocale locale(sprak);
    const QString qttranslationsPath(":/i18n/qttranslations");
    QTranslator qtTranslator;

    if(qtTranslator.load(locale, "qt", "_", qttranslationsPath)) {
        QApplication::installTranslator(&qtTranslator);
    }

    QTranslator qtBaseTranslator;

    if(qtBaseTranslator.load(locale, "qtbase", "_", qttranslationsPath)) {
        QApplication::installTranslator(&qtBaseTranslator);
    }

    /*    */
    if(theme == "dark") {
        // Ange det mörka temat för Fusion
        QPalette darkPalette;
        darkPalette.setColor(QPalette::Window, QColor(53, 53, 53));
        darkPalette.setColor(QPalette::WindowText, Qt::white);
        darkPalette.setColor(QPalette::Base, QColor(25, 25, 25));
        darkPalette.setColor(QPalette::AlternateBase, QColor(53, 53, 53));
        darkPalette.setColor(QPalette::ToolTipBase, Qt::black);
        darkPalette.setColor(QPalette::ToolTipText, Qt::white);
        darkPalette.setColor(QPalette::Text, Qt::white);
        darkPalette.setColor(QPalette::Button, QColor(53, 53, 53));
        darkPalette.setColor(QPalette::ButtonText, Qt::white);
        darkPalette.setColor(QPalette::BrightText, Qt::red);
        darkPalette.setColor(QPalette::Link, QColor(42, 130, 218));
        darkPalette.setColor(QPalette::Highlight, QColor(42, 130, 218));
        darkPalette.setColor(QPalette::HighlightedText, Qt::black);
        app.setPalette(darkPalette);
    } else if(theme == "light") {
        // Ange det ljusa temat för Fusion
        QPalette lightPalette;
        lightPalette.setColor(QPalette::Window, Qt::white);
        lightPalette.setColor(QPalette::WindowText, Qt::black);
        lightPalette.setColor(QPalette::Base, Qt::white);
        lightPalette.setColor(QPalette::AlternateBase, Qt::lightGray);
        lightPalette.setColor(QPalette::ToolTipBase, QColor(255, 255, 220));
        lightPalette.setColor(QPalette::ToolTipText, Qt::black);
        lightPalette.setColor(QPalette::Text, Qt::black);
        lightPalette.setColor(QPalette::Button, Qt::white);
        lightPalette.setColor(QPalette::ButtonText, Qt::black);
        lightPalette.setColor(QPalette::BrightText, Qt::red);
        lightPalette.setColor(QPalette::Link, QColor(42, 130, 218));
        lightPalette.setColor(QPalette::Highlight, QColor(42, 130, 218));
        lightPalette.setColor(QPalette::HighlightedText, Qt::black);
        app.setPalette(lightPalette);
    }

    /*   */
    QTranslator translator;
    settings.beginGroup("Language");
    QString testlanguage = settings.value("testlanguage").toString();
    QString language = settings.value("language", "").toString();
    settings.endGroup();
    QFileInfo fi(testlanguage);

    if((language.isEmpty()) && (fi.exists())) {
        if(translator.load(testlanguage)) {
            QApplication::installTranslator(&translator);
        }
    }
// END Test translation
    else {
        // ELSE
        settings.beginGroup("Language");
        QString sp = settings.value("language", "").toString();
        settings.endGroup();
        const QString translationPath = ":/i18n/_complete";
//        const QString built_inTranslation = ":/i18n";

        if(sp == "") {
            sp = QLocale::system().name();

            if(translator.load(translationPath + "_" + sp + ".qm")) {
                settings.beginGroup("Language");
                settings.setValue("language", sp);
                settings.endGroup();
                /*  */
                /*  */
                QApplication::installTranslator(&translator);
            } else if(sp != "en_US") {
                QMessageBox::information(
                    nullptr, DISPLAY_NAME " " VERSION,
                    DISPLAY_NAME
                    " is unfortunately not yet translated into your language, the "
                    "program will start with English menus.");
                settings.beginGroup("Language");
                settings.setValue("language", "en_US");
                settings.endGroup();
            }
        } else {
            if(translator.load(translationPath + "_" + sp + ".qm")) {
                QApplication::installTranslator(&translator);
            }
        }

        // END ELSE Test translation
    }

    Newprg *mNewPrg = new Newprg;
// #if defined(Q_OS_LINUX)
    ZoomDisabler *zoomDisabler = new ZoomDisabler;
// #endif
// End config
    QObject::connect(&app, &QCoreApplication::aboutToQuit,
                     [mNewPrg]() -> void { mNewPrg->setEndConfig(); });
    mNewPrg->show();
    int r = QApplication::exec();
    return r;
}
