// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>
//
//          streamCapture2
//          (C) Copyright  2016 - 2024 Ingemar Ceicer
//          https://gitlab.com/posktomten/streamcapture2/
//          programming@ceicer.com
//
//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
// ><(((*> <(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*> ><(((*>
#include <QNetworkReply>
#include "newprg.h"

void Newprg::userMessage()
{
    QSettings settings(QSettings::IniFormat, QSettings::UserScope, DISPLAY_NAME,
                       EXECUTABLE_NAME);
    settings.beginGroup("Language");
    QString language = settings.value("language", "en_US").toString();
    settings.endGroup();

    if(language == "sv_SE") {
        language = USER_MESSAGE_SV;
    } else {
        language = USER_MESSAGE;
    }

    QUrl url(language);
    auto *nam = new QNetworkAccessManager(nullptr);
    auto *reply = nam->get(QNetworkRequest(url));
//    reply->waitForBytesWritten(1000);

    if(reply->error() != QNetworkReply::NoError) {
        return;
    }

    QObject::connect(
        reply, &QNetworkReply::finished,
    [reply, this] {
        QByteArray *bytes = new QByteArray;
        *bytes = reply->readAll();

        if(reply->error() == QNetworkReply::ContentNotFoundError) {
            return;
        }
        QString s(*bytes);
        s = s.trimmed();

        if(s.isEmpty())
        {
            return;
        }
        ui->teOut->setText(s);
//        QTextCursor cursor = ui->teOut->textCursor();
        ui->teOut->moveCursor(QTextCursor::Start);

    });
}
